<template>
  <div
    :class="`${
      isCollapse ? 'is-collapse-menu' : ''
    } relative side-bar-container`"
  >
    <el-button class="sidebar-toggler" @click="handleCollapseMenu">
      <span
        ><font-awesome-icon
          icon="play"
          class="transition-transform duration-500"
          :class="{ 'rotate-180': !isCollapse }"
      /></span>
    </el-button>
    <div
      class="el-menu-item logo"
      style="padding: 0 10px"
      :style="!isCollapse ? 'max-width: 288px;' : ''"
    >
      <el-icon style="width: 40px">
        <nuxt-link to="/" style="width: 40px">
          <img
            v-if="!miniLogo.IsHidden"
            class="w-[40px] h-[40px]"
            loading="lazy"
            :src="miniLogo.ImagePath"
          />
        </nuxt-link>
      </el-icon>
      <div
        v-if="!logo.IsHidden"
        class="max-w-[0px] w-full flex items-center justify-center h-[72px]"
        :style="!isCollapse ? 'max-width: 100%;' : 'display: none;'"
      >
        <nuxt-link :to="logo.HyperLink ? `/${logo.HyperLink}` : '/'">
          <img
            class="w-[155px] max-h-[72px] object-contain"
            loading="lazy"
            :src="logo.ImagePath"
          />
        </nuxt-link>
      </div>
    </div>
    <el-menu
      default-active="2"
      class="el-menu-vertical-demo"
      :collapse="isCollapse"
    >
      <el-menu-item
        :class="`${
          isCollapse ? 'is-collapse-menu' : ''
        } menu-tab-item-search mt-[20px]`"
        @click="openGameSearchModal"
      >
        <el-icon
          ><font-awesome-icon icon="magnifying-glass" class="text-[20px]"
        /></el-icon>
        <template v-if="!isCollapse" #title>
          <div class="ml-[29px] flex justify-between w-full items-center">
            <span>{{ $t("search") }}</span>
            <font-awesome-icon
              icon="play"
              class="text-[5px] absolute right-[10px]"
            />
          </div>
        </template>
      </el-menu-item>
      <GameProviderCategory :is-collapse="isCollapse" />
      <GameProviderCategory
        :is-collapse="isCollapse"
        :is-game-provider="true"
      />
      <nuxt-link
        v-for="(menu, index) in menuTabHeaders"
        :key="index"
        :to="!menu.TabURL?.includes('games') ? menu.TabURL : '/games/HotGames__n__gt'"
      >
        <el-menu-item
          :class="{ active: tabSelected === String(menu.TabURL).toLowerCase() }"
        >
          <el-icon
            :class="`menu-tab-icon-${menu?.TabType.replace(
              ' ',
              '-'
            ).toLowerCase()} menu-tab-item`"
          ></el-icon>
          <template #title>
            <span>{{ $t(menu?.TabType.replace(" ", "_").toLowerCase()) }}</span>
          </template>
        </el-menu-item>
      </nuxt-link>
      <nuxt-link to="/promotion" v-if="isAllowPromotionTab">
        <el-menu-item
          :class="`${tabSelected === '/promotion' ? 'active' : ''}`"
        >
          <el-icon class="menu-tab-icon-promotion"></el-icon>
          <template #title
            ><span>{{ $t("promotion") }}</span></template
          >
        </el-menu-item>
      </nuxt-link>
      <nuxt-link v-if="isAppDownloadEnabled" to="/app-download">
        <el-menu-item :class="{ active: tabSelected === '/app-download' }">
          <el-icon class="menu-tab-icon-app-download"></el-icon>
          <template #title
            ><span>{{ $t("app_download") }}</span></template
          >
        </el-menu-item>
      </nuxt-link>
      <nuxt-link to="/term-condition">
        <el-menu-item
          :class="`${
            tabSelected === '/term-condition' ? 'active' : ''
          } term-condition-item`"
        >
          <el-icon><font-awesome-icon icon="file" /></el-icon>
          <template #title
            ><span>{{ $t("term_condition") }}</span></template
          >
        </el-menu-item>
      </nuxt-link>
      <div
        style="border-bottom: solid 1px var(--border-color); height: 15px"
      ></div>
      <Language
        :get-asset-image="getAssetImage"
        :default-language="String(defaultLanguage)"
        :default-language-for-display="String(defaultLanguageForDisplay)"
        :is-collapse="isCollapse"
      />

      <switch-modern-theme
        v-if="!isHidden"
        :hide-label="isCollapse"
        :is-dark="isDark"
        @toggle="$emit('toggle')"
      />
    </el-menu>
  </div>
  <SearchModal :is-open="isGameSearchOpen" @close="closeGameSearchModal" />
</template>
<script lang="ts" setup>
import Language from "./Language.client.vue";
import GameProviderCategory from "./GameProviderCategory.client.vue";
import SearchModal from "./search-modal/SearchModal.client.vue";
import commonHelper from "@/utils/commonHelper";
import {
  useHeaderComponent,
  useLanguageComponent,
} from "@/composables/useTheme";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";

defineProps({
  logo: {
    type: Object as PropType<IThemePropertiesFromApi>,
    required: true,
  },
  miniLogo: {
    type: Object as PropType<IThemePropertiesFromApi>,
    required: true,
  },
  handleCollapseMenu: {
    type: Function,
    required: true,
  },
  isCollapse: {
    type: Boolean,
    required: true,
  },
  isDark: {
    type: Boolean,
    required: true,
  },
  isHidden: {
    type: Boolean,
    default: false,
  },
});
defineEmits(["toggle"]);
const { isAppDownloadEnabled, menuTabHeaders, tabSelected, isAllowPromotionTab } =
  useHeaderComponent();
const { getAssetImage } = commonHelper;
const sportIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/sports-b.png"
)}`;
const activeSportIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/sports-a.png"
)}`;
const vSportIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/virtual-sports-b.png"
)}`;
const activeVSportIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/virtual-sports-a.png"
)}`;
const lCasinoIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/live-casino-b.png"
)}`;
const activeLCasinoIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/live-casino-a.png"
)}`;
const gameIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/games-b.png"
)}`;
const activeGameIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/games-a.png"
)}`;
const kenoIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/keno-b.png"
)}`;
const activeKenoIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/keno-a.png"
)}`;
const cockIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/cock-fight-b.png"
)}`;
const activeCockIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/cock-fight-a.png"
)}`;
const pokerIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/poker-b.png"
)}`;
const activePokerIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/poker-a.png"
)}`;
const lotteryIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/lottery-b.png"
)}`;
const activeLotteryIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/lottery-a.png"
)}`;
const promotionIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/promotion-b.png"
)}`;
const activePromotionIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/promotion-a.png"
)}`;
const appIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/download-b.png"
)}`;
const activeAppIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/download-a.png"
)}`;
const gameTypeIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/games-type.png"
)}`;
const gameProviderIcon = `url(${getAssetImage(
  "assets/theme/black_modern_1/images/sidebar/games-provider.png"
)}`;
const { defaultLanguage, defaultLanguageForDisplay } = useLanguageComponent();
const isGameSearchOpen = ref(false);
const openGameSearchModal = () => {
  isGameSearchOpen.value = true;
};
const closeGameSearchModal = () => {
  isGameSearchOpen.value = false;
};
</script>
<style scoped>
.sidebar-toggler {
  position: absolute;
  top: 18px;
  right: -20px;
  display: flex;
  justify-content: center;
  align-items: center;
  height: 40px;
  width: 40px;
  font-size: 12px;
  cursor: pointer;
  color: var(--text2);
  transition: none;
  background: var(--button-bg);
  border: 1px solid var(--border-color);
  border-radius: 20px;
  z-index: 1;
}
.sidebar-toggler span {
  display: flex;
  align-items: center;
  justify-content: center;
  width: 24px;
  height: 24px;
  font-size: 12px;
  background-color: var(--button-bg);
  box-shadow: var(--box-shadow);
  border-radius: 12px;
}
.side-bar-container {
  max-width: 72px;
  width: 100%;
  height: 100vh;
  position: fixed;
}
.side-bar-container:not(.is-collapse-menu) {
  max-width: 288px;
}
.el-menu-vertical-demo {
  width: 72px;
  height: calc(100vh - 72px);
  background: var(--background2);
  border-right: solid 1px var(--border-color);
  overflow: auto;
  padding-bottom: 40px;
}
/* Hide scrollbar for Chrome, Safari and Opera */
.el-menu-vertical-demo::-webkit-scrollbar {
  display: none;
}
/* Hide scrollbar for IE, Edge and Firefox */
.el-menu-vertical-demo {
  -ms-overflow-style: none; /* IE and Edge */
  scrollbar-width: none; /* Firefox */
}
.el-menu-vertical-demo:not(.el-menu--collapse) {
  width: 288px;
}
.side-bar-container .logo {
  border-bottom: solid 1px var(--border-color);
  border-right: solid 1px var(--border-color);
  height: 72px;
  width: 100%;
  max-width: 72px;
  background: var(--background2);
  transition: none;
}
.el-menu-item {
  height: 50px;
  color: var(--text2);
}
.el-menu-item.active,
.term-condition-item.active i,
.term-condition-item:hover i {
  color: var(--primary-fallback);
}
.el-menu-item {
  background: unset;
}
.side-bar-container i {
  font-size: 24px;
  line-height: normal;
  transition: none;
  cursor: pointer;
  border-radius: 8px;
  color: var(--text2);
  margin-right: 15px;
}
:deep(.theme-switch .el-switch) {
  margin-left: 10px !important;
}
.menu-tab-item-search {
  box-shadow: var(--box-shadow-inset);
}
.menu-tab-item-search:hover i {
  color: var(--text2);
}
.menu-tab-item-search:not(.is-collapse-menu) {
  max-width: 255px;
}
.menu-tab-item-search i {
  position: absolute;
  left: 8px;
}
.menu-tab-icon-sports {
  background: v-bind("sportIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.el-menu-item:hover .menu-tab-icon-sports,
.el-menu-item.active .menu-tab-icon-sports {
  background: v-bind("activeSportIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.menu-tab-icon-virtual-sports {
  background: v-bind("vSportIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.el-menu-item:hover .menu-tab-icon-virtual-sports,
.el-menu-item.active .menu-tab-icon-virtual-sports {
  background: v-bind("activeVSportIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.menu-tab-icon-live-casino {
  background: v-bind("lCasinoIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.el-menu-item:hover .menu-tab-icon-live-casino,
.el-menu-item.active .menu-tab-icon-live-casino {
  background: v-bind("activeLCasinoIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.menu-tab-icon-games {
  background: v-bind("gameIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.el-menu-item:hover .menu-tab-icon-games,
.el-menu-item.active .menu-tab-icon-games {
  background: v-bind("activeGameIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.menu-tab-icon-keno {
  background: v-bind("kenoIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.el-menu-item:hover .menu-tab-icon-keno,
.el-menu-item.active .menu-tab-icon-keno {
  background: v-bind("activeKenoIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.menu-tab-icon-cock-fight {
  background: v-bind("cockIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.el-menu-item:hover .menu-tab-icon-cock-fight,
.el-menu-item.active .menu-tab-icon-cock-fight {
  background: v-bind("activeCockIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.menu-tab-icon-poker {
  background: v-bind("pokerIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.el-menu-item:hover .menu-tab-icon-poker,
.el-menu-item.active .menu-tab-icon-poker {
  background: v-bind("activePokerIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.menu-tab-icon-lottery {
  background: v-bind("lotteryIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.el-menu-item:hover .menu-tab-icon-lottery,
.el-menu-item.active .menu-tab-icon-lottery {
  background: v-bind("activeLotteryIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.menu-tab-icon-promotion {
  background: v-bind("promotionIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.el-menu-item:hover .menu-tab-icon-promotion,
.el-menu-item.active .menu-tab-icon-promotion {
  background: v-bind("activePromotionIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.menu-tab-icon-app-download {
  background: v-bind("appIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.el-menu-item:hover .menu-tab-icon-app-download,
.el-menu-item.active .menu-tab-icon-app-download {
  background: v-bind("activeAppIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
</style>
<style>
.side-bar-container .menu-tab-item-search,
.side-bar-container .special-menu-tab-item {
  height: 40px;
  max-width: 40px;
  width: 100%;
  background-color: var(--button-bg);
  border-radius: 8px;
  margin-left: 10px;
  margin-bottom: 10px;
  transition: none;
}
.special-menu-tab-item {
  box-shadow: var(--box-shadow);
}
.special-menu-tab-item:not(.is-collapse-menu) {
  max-width: 255px;
}
.special-menu-tab-item i {
  position: absolute;
  left: 8px;
}
.side-bar-container .el-drawer,
.select-provider .el-drawer,
.statistic .el-drawer {
  --el-drawer-bg-color: var(--background2);
  --el-drawer-padding-primary: 40px;
  min-width: 540px !important;
}
.side-bar-container #el-drawer__title,
.select-provider #el-drawer__title,
.statistic #el-drawer__title {
  font-size: 44px;
  font-weight: 700;
  color: var(--title-font-color);
}
.side-bar-container .el-drawer__close-btn,
.select-provider .el-drawer__close-btn,
.statistic .el-drawer__close-btn {
  padding: 0;
  max-width: 40px;
  width: 100%;
  height: 40px;
  border-radius: 6px;
  background-color: var(--button-bg);
  box-shadow: var(--box-shadow);
}
.side-bar-container .el-drawer__close-btn:hover,
.select-provider .el-drawer__close-btn:hover,
.statistic .el-drawer__close-btn:hover {
  background: var(--button-bg-hover);
}
.side-bar-container .el-drawer__body,
.select-provider .el-drawer__body,
.statistic .el-drawer__body {
  padding-top: unset;
}
.menu-tab-icon-games-type {
  background: v-bind("gameTypeIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.menu-tab-icon-games-provider {
  background: v-bind("gameProviderIcon") no-repeat;
  background-size: 100%;
  background-position: center;
}
.side-bar-container .el-card,
.select-provider .el-card,
.statistic .el-card {
  height: 130px;
  padding: 10px;
  background-color: var(--button-bg);
  box-shadow: var(--box-shadow);
  border-radius: 8px;
  transition: all 0.2s ease-out 0s;
  border: unset;
  cursor: pointer;
}
.card-game-pc-wrapper {
  display: grid;
  grid-template-columns: repeat(auto-fill, minmax(145px, 1fr));
  grid-gap: 20px;
  padding-top: 10px;
}
.side-bar-container .el-card__body,
.select-provider .el-card__body,
.statistic .el-card__body {
  --el-card-padding: 0px;
}
.card-image-wrapper {
  border-bottom: 1px solid var(--border-color);
}
</style>
